#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>

#include "Token.H"

int Token::Type ()
{
  return type;
}

char *Token::String ()
{
  if (type == TYPE_STRING)
    {
      return string;
    }
  return NULL;
}

int Token::Number ()
{
  return number;
}

Token *Token::Array (int element)
{
  if (element >= number || type != TYPE_ARRAY) return NULL;
  
  int cntr = 0;
  Element *p = array;
  while (cntr < element && p != NULL)
    {
      p = p->next;
      cntr++;
    }
  return p->token;
}

#define GET_CHAR chr = fgetc (file);

static int chr;

Token::Token (FILE *file, char recurse)
{
  if (!recurse || chr == '{' || chr == '*')
    {
      type = TYPE_ARRAY;
      array = NULL;
      number = 0;
      
      if (chr != '*')
	{
	  Element *p, *q;
	  GET_CHAR;
	  if (chr == ' ') GET_CHAR;
	  while ( chr != (recurse ? '}' : '\n'))
	    {
	      q = new Element;
	      q->token = new Token (file, 1);
	      if (array) p->next = q;
	      else array = q;
	      p = q;
	      p->next = NULL;
	      number++;
	    }
	}
      if (chr != '\n') GET_CHAR;
      
      return;
    }
  
  number = 0;
  while (chr >= '0' && chr <= '9')
    {
      number *= 10;
      number += chr - '0';
      GET_CHAR;
    }
  
  if (chr == 'H')
    {
      int len;
      type = TYPE_STRING;
      string = new char[number + 1];
      string[0] = '\0';
      while ((len = strlen (string)) < number)
	{
	  fgets (string + len, number + 1 - len, file);
	}
      GET_CHAR;
      if (chr != '\n') GET_CHAR;
      return;
    }
  
  if (chr != ' ' && chr != '\n')
    {
      cerr << "Protocol parser error" << endl;
      exit (EXIT_FAILURE);
    }
  if (chr == ' ') GET_CHAR;
  
  type = TYPE_NUMBER;
}

Token::~Token ()
{
}
